apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: {{ .Chart.Name }}
  labels:
    app: {{ .Chart.Name }}
spec:
  replicas: 1
  serviceName: {{ .Chart.Name }}
  selector:
    matchLabels:
      app: {{ .Chart.Name }}
  template:
    metadata:
      labels:
        app: {{ .Chart.Name }}
      {{- with .Values.pod.annotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    spec:
      containers:
      - name: {{ .Chart.Name }}
        image: "{{ .Values.image.registry }}/{{ .Values.image.repository }}:{{ .Values.image.tag }}"
        imagePullPolicy: {{ .Values.imagePullPolicy }}
        {{- with .Values.env }}
        env: 
          {{- toYaml . | nindent 10}}
        {{- end }}
        {{- with .Values.envFrom }}
        envFrom: 
          {{- toYaml . | nindent 10}}
        {{- end }}
        ports:
        - name: http
          containerPort: 5055
        {{- with .Values.livenessProbe }}
        livenessProbe:
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.readinessProbe }}
        readinessProbe:
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.resources }}
        resources: 
          {{- toYaml . | nindent 10}}
        {{- end }}
        volumeMounts:
          - name: config
            mountPath: "/config"
          {{- with .Values.volumeMounts }}
            {{- toYaml . | nindent 10 }}
          {{- end }}
      {{- with .Values.volumes }}
      volumes:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ .Chart.Name }}
      {{- with .Values.securityContext }}
      securityContext:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      
  volumeClaimTemplates:
  - metadata:
      name: config
    spec:
      accessModes: {{ .Values.persistence.config.accessModes }}
      storageClassName: {{ .Values.persistence.config.storageClassName | quote }}
      resources:
        requests:
          storage: {{ .Values.persistence.config.size | quote }}
